var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter, ComponentFactoryResolver } from '@angular/core';
import { Router } from '@angular/router';
import { PinyinService } from '../pinyin.service';
let AutoCompleteComponent = class AutoCompleteComponent {
    constructor(resolver, router, pinyinService) {
        this.resolver = resolver;
        this.router = router;
        this.pinyinService = pinyinService;
        this.textChangeEvent = new EventEmitter();
        this.show_source = [];
    }
    ngOnInit() {
    }
    ngOnChanges(changes) {
    }
    blur() {
        this.showContainer = false;
    }
    focus() {
        this.changeText();
    }
    press(event) {
        if (event.key == 'Tab') {
            event.preventDefault();
            for (let i = 0; i < this.show_source.length; i++) {
                if (this.show_source[i].show) {
                    this.show_source[i].show = false;
                    if (i == this.show_source.length - 1) {
                        this.show_source[0].show = true;
                    }
                    else {
                        this.show_source[i + 1].show = true;
                    }
                    break;
                }
            }
        }
        if (event.key == 'Enter') {
            for (let _c of this.show_source) {
                if (_c.show) {
                    this.text = _c.title;
                }
            }
            this.showContainer = false;
        }
    }
    changeText() {
        if (this.text == null) {
            this.text = "";
        }
        this.show_source = [];
        let tempSource = this.source.filter(item => {
            return item.indexOf(this.text) >= 0 || this.pinyinService.toPinyin(item).indexOf(this.text) >= 0;
        });
        for (let i = 0; i < tempSource.length; i++) {
            let _show = i == 0;
            this.show_source.push({
                title: tempSource[i],
                show: _show
            });
        }
        this.showContainer = true;
    }
    selectText(t) {
        this.text = t;
        this.showContainer = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Object)
], AutoCompleteComponent.prototype, "source", void 0);
__decorate([
    Input(),
    __metadata("design:type", Object)
], AutoCompleteComponent.prototype, "width", void 0);
__decorate([
    Output(),
    __metadata("design:type", Object)
], AutoCompleteComponent.prototype, "textChangeEvent", void 0);
AutoCompleteComponent = __decorate([
    Component({
        selector: 'dc-auto-component',
        template: `
  <div class="display-flex width-100 flex-direction-column" [style.position]="'relative'" [style.max-width]="width">
    <input type="text" [(ngModel)]="text" (keydown)="press($event)" (blur)="blur()" (focus)="focus()" (ngModelChange)="changeText()">
    <div class="complete-container width-100 flex-direction-column" *ngIf="showContainer">
        <div *ngFor="let c of show_source" class="source-title" [ngClass]="{active:c.show}" (click)="selectText(c)">
            {{c.title}}
        </div> 
    </div>
</div>
  `,
        styles: [
            '.title.active{color: red}',
            '.title{cursor: pointer;}',
            '.complete-container{position: absolute;top:24px;background-color: wheat;}',
            '.source-title{max-width: 100%;overflow: hidden;text-overflow: ellipsis;cursor: pointer;}',
            '.source-title.active{color: rebeccapurple;}',
        ]
    }),
    __metadata("design:paramtypes", [ComponentFactoryResolver, Router, PinyinService])
], AutoCompleteComponent);
export { AutoCompleteComponent };
//# sourceMappingURL=auto.component.component.js.map